using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Aufgabengenerator;

namespace AufgabenFrontend
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Rechenaufgabe : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox Aufgabe;
		private System.Windows.Forms.Button Stimmt;
		private System.Windows.Forms.TextBox Ergebnis;
		private System.Windows.Forms.TextBox Status;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private Generator agen;
		private Aufgabe a;
		private AufgabenTutor.CRechenaufgabenTutorClass tutor;

		public Rechenaufgabe ()
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			agen = new Generator(0,100);
			a = agen.Erzeuge();
			Aufgabe.Text = a.Beschreibung;
			Ergebnis.Focus();

			// Creating a new tutor
			tutor = new AufgabenTutor.CRechenaufgabenTutorClass();
			tutor.NeueAufgabe();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Aufgabe = new System.Windows.Forms.TextBox();
			this.Stimmt = new System.Windows.Forms.Button();
			this.Ergebnis = new System.Windows.Forms.TextBox();
			this.Status = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// Aufgabe
			// 
			this.Aufgabe.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Aufgabe.Location = new System.Drawing.Point(16, 40);
			this.Aufgabe.Name = "Aufgabe";
			this.Aufgabe.ReadOnly = true;
			this.Aufgabe.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.Aufgabe.Size = new System.Drawing.Size(472, 31);
			this.Aufgabe.TabIndex = 0;
			this.Aufgabe.Text = "";
			this.Aufgabe.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// Stimmt
			// 
			this.Stimmt.Location = new System.Drawing.Point(16, 136);
			this.Stimmt.Name = "Stimmt";
			this.Stimmt.Size = new System.Drawing.Size(472, 32);
			this.Stimmt.TabIndex = 1;
			this.Stimmt.Text = "Stimmt mein Ergebnis?";
			this.Stimmt.Click += new System.EventHandler(this.Stimmt_Click);
			// 
			// Ergebnis
			// 
			this.Ergebnis.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Ergebnis.Location = new System.Drawing.Point(16, 80);
			this.Ergebnis.Name = "Ergebnis";
			this.Ergebnis.Size = new System.Drawing.Size(472, 31);
			this.Ergebnis.TabIndex = 2;
			this.Ergebnis.Text = "";
			// 
			// Status
			// 
			this.Status.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Status.Location = new System.Drawing.Point(16, 184);
			this.Status.Name = "Status";
			this.Status.ReadOnly = true;
			this.Status.Size = new System.Drawing.Size(472, 22);
			this.Status.TabIndex = 3;
			this.Status.Text = "Los gehts ...";
			// 
			// Rechenaufgabe
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.Status,
																		  this.Ergebnis,
																		  this.Stimmt,
																		  this.Aufgabe});
			this.Name = "Rechenaufgabe";
			this.Text = "Rechenaufgaben";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Rechenaufgabe());
		}

		private void Stimmt_Click(object sender, System.EventArgs e)
		{
			int erg;
			string text;

			if (Ergebnis.Text.Length == 0)
				erg = 0;
			else
				erg = Convert.ToInt32(Ergebnis.Text);

			if (a.Stimmt(erg)) 
			{
				tutor.Richtig();
				tutor.Bemerkung(out text);
				Status.Text = text;
				a = agen.Erzeuge();
				Aufgabe.Text = a.Beschreibung;
				tutor.NeueAufgabe();
			}
			else 
			{
				tutor.Falsch();
				tutor.Bemerkung(out text);
				Status.Text = text;
			}
			Ergebnis.Text = "";
			Ergebnis.Focus();
		}
	}
}
