using System;

namespace Aufgabengenerator
{
	/// <summary>
	/// Dieser Generator ist in der Lage einfach Rechenaufgaben zu erzeugen.
	/// Ein Frontend kann diese Aufgaben stellen und die Benutzereingaben
	/// anschlieend berprfen.
	/// </summary>
	public class Generator
	{
		public Generator ( int a_minimum, int a_maximum )
		{
			minimum = a_minimum;
			maximum = a_maximum;
			zahlengenerator = new Random();
		}

		public Aufgabe Erzeuge () 
		{
			return Addition ();
		}

		private Aufgabe Addition () 
		{
			int ergebnis = zahlengenerator.Next(minimum,maximum+1);
			int x = zahlengenerator.Next(minimum,ergebnis+1);
			int y = ergebnis - x;
			string b = x.ToString() + " + " + y.ToString();
			return new Aufgabe(b,ergebnis);
		}

		private int minimum;
		private int maximum;
		private Random zahlengenerator;
	}

	/// <summary>
	/// Eine Aufgabe.
	/// </summary>
	public class Aufgabe 
	{
		internal Aufgabe ( string a_beschreibung, int a_ergebnis ) 
		{
			beschreibung = a_beschreibung;
			ergebnis = a_ergebnis;
		}

		private string beschreibung;
		private int ergebnis;

		public string Beschreibung 
		{
			get 
			{
				return beschreibung;
			}
		}

		public bool Stimmt ( int wert ) 
		{
			return ergebnis == wert;
		}
	}
}
